// Variables
var userName = "";
var userPoints = 0;
var userRank = 0;
var userColor = "";
var showRank = false;

var blueScore = 0;
var blueRank = 0;
var greenScore = 0;
var greenRank = 0;
var purpleScore = 0;
var purpleRank = 0;
var orangeScore = 0;
var orangeRank = 0;
var scores;
var versionURL = "http://homepage.usask.ca/~ces922/files/version.html";
var dataURL = "http://macheist.seems.nl/access/csv.php?num=4";
var statsURL = "http://macheist.seems.nl";
var threadURL = "http://www.macheist.com/forums/viewtopic.php?pid=218187";
var downloadURL = "http://homepage.usask.ca/~ces922/files/mhteamscores.zip";
var pointsURL = "http://rdic.mmnow.nl/api/txt/bot.php?user=";
var pointURL = "http://rdic.mmnow.nl/";


//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
function load()
{
	prefsGet();
    setupParts();
	updateCheck();
	document.getElementById("rank").style.opacity = 0.0;
	updatePoints();
	showRankChanged();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
function remove()
{
	widget.setPreferenceForKey (null, "user");
	widget.setPreferenceForKey (null, "points");
	widget.setPreferenceForKey (null, "rank");
	widget.setPreferenceForKey (null, "showRank");

}

//
// Function: hide()
// Called when the widget has been hidden
function hide()
{
	prefsSet();
}

//
// Function: show()
// Called when the widget has been shown
function show()
{
	updateDisplay();
	updatePoints();
}
function sync(){}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
// event: onClick event from the info button
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    if (window.widget)
        widget.prepareForTransition("ToBack");
    front.style.display = "none";
    back.style.display = "block";
    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
// event: onClick event from the done button
function showFront(event)
{
	if(userName != document.getElementById("userfield").value)
	{
		userName = document.getElementById("userfield").value;
		updatePoints();
	}
	updateDisplay();
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    if (window.widget)
        widget.prepareForTransition("ToFront");
    front.style.display="block";
    back.style.display="none";
    if (window.widget)
        setTimeout('widget.performTransition();', 0);
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
	widget.onsync = sync;
}

function version_download(){
	widget.openURL(downloadURL);
}
function version_ignore(){
	updateDisplay();
	document.getElementById("newVer").style.display = "none";
	aniFadeIn("scores");
}
function cursor_over(){
	document.body.style.cursor = "pointer";
}
function cursor_exit(){
	document.body.style.cursor = "default";
}
function link_suggestion(){
	widget.openURL(threadURL);
}
function link_stats(){
	widget.openURL(statsURL);
}
function link_points(){
	widget.openURL(pointURL);
}

// Saves the preferences for the widget
function prefsSet()
{
	if(userName == "")
		widget.setPreferenceForKey(null, "user");
	else
		widget.setPreferenceForKey(userName, "user");
		
	if(userPoints == 0)
		widget.setPreferenceForKey(null, "points");
	else
		widget.setPreferenceForKey(userPoints, "points");
		
	if(userRank == 0)
		widget.setPreferenceForKey(null, "rank");
	else
		widget.setPreferenceForKey(userRank, "rank");
}

// Gets the preferences for the widget
function prefsGet()
{
	if(window.widget)
	{
		var userPref = widget.preferenceForKey("user");
		if (userPref && userPref.length > 0){
			userName = userPref;
			document.getElementById("userfield").value = userName;				
		}
		var userPref = widget.preferenceForKey("points");
		if (userPref && userPref.length > 0){
			userPoints = userPref;
		}
		var userPref = widget.preferenceForKey("rank");
		if (userPref && userPref.length > 0){
			userRank = userPref;
		}
		var pref = widget.preferenceForKey("show-rank");
		// existence of preference means to show lows
		if (pref != null)
		{
			showRank = true;
			document.getElementById('rankbox').checked = showRank;
		}
	}
}


//
// Sets the color to the corrent position and sets the score
function setRank(color, score)
{
	var rank = 0;
	var i = 0;
	for(i=0; i<5 && scores[i] != score; i++){}
	rank = i + 1;
	document.getElementById("blue" + rank).style.opacity = 0.0;
    document.getElementById("green" + rank).style.opacity = 0.0;
    document.getElementById("orange" + rank).style.opacity = 0.0;
    document.getElementById("purple" + rank).style.opacity = 0.0;        
    document.getElementById(color + rank).style.opacity = 1.0;
	
	var element = document.getElementById("score" + rank);
    if (element) {
        element.innerText = _addCommas(score);
    }
}

function showRankChanged ()
{
	showRank = document.getElementById('rankbox').checked;

	if (window.widget)
	{
		if (showRank)
			widget.setPreferenceForKey(true, "show-rank");
		else
			widget.setPreferenceForKey (null, "show-rank");
	}
	if (showRank)
	{
		document.getElementById("logo-vault").style.opacity = 0.0;
		document.getElementById("rank").style.opacity = 1.0;
	}
	else if(!showRank)
	{
		document.getElementById("logo-vault").style.opacity = 1.0;
		document.getElementById("rank").style.opacity = 0.0;
	}
}

//
// Checks if there is a new version of the widget to update to
function updateCheck()
{
    var onloadHandler = function() { updateCheckRun(xmlRequest); };
    var xmlRequest = new XMLHttpRequest();
    xmlRequest.onload = onloadHandler;
    xmlRequest.open("GET", versionURL);
    xmlRequest.setRequestHeader("Cache-Control", "no-cache");
    xmlRequest.send(null);
}
function updateCheckRun(xmlRequest) 
{
	if (xmlRequest.status == 200) {		
		var current = parseFloat(_getVersion());
		var avail = parseFloat(xmlRequest.responseText);
		document.getElementById("scores").style.opacity = 0.0;
		// Compare available and current version
		if (avail > current)
		{
			document.getElementById("newVer").style.opacity = 1.0;
		}
		else
		{
			document.getElementById("newVer").style.display = "none";
			updateDisplay();
			document.getElementById("scores").style.opacity = 1.0;
		}
	}
	else {
		alert("Error fetching data: HTTP status " + xmlRequest.status);
	}
}

//
// Gets the data and sets the widget to display it.
function updateDisplay()
{
    var onloadHandler = function() { updateDisplayRun(xmlRequest); };
    var xmlRequest = new XMLHttpRequest();
    xmlRequest.onload = onloadHandler;
    xmlRequest.open("GET", dataURL);
    xmlRequest.setRequestHeader("Cache-Control", "no-cache");
    xmlRequest.send(null);
}
function updateDisplayRun(xmlRequest) 
{
	if (xmlRequest.status == 200)
    {
        var data = xmlRequest.responseText.split(",");
        
		greenScore = parseInt(data[5]);		
		blueScore = parseInt(data[8]);
        purpleScore = parseInt(data[11]);			
        orangeScore = parseInt(data[14]);
		
		scores = new Array(greenScore, blueScore, purpleScore, orangeScore);
		scores.sort(function sortNumber(a,b){return b - a;});
		
		setRank("blue", blueScore);
		setRank("green", greenScore);
		setRank("purple", purpleScore);
		setRank("orange", orangeScore);
	}
	else{
		alert("Error fetching data: HTTP status " + xmlRequest.status);
	}
}

//
// Gets the points for the precified user
function updatePoints()
{
	if(userName != "")
	{
		document.getElementById("logo-text").style.opacity = 0.0;
		document.getElementById("points").style.opacity = 1.0;
		var onloadHandler = function() { updatePointsRun(xmlRequest); };
		var xmlRequest = new XMLHttpRequest();
		xmlRequest.onload = onloadHandler;
		var URL = pointsURL+userName;
		xmlRequest.open("GET", URL);
		xmlRequest.setRequestHeader("Cache-Control", "no-cache");
		xmlRequest.send(null);
	}
	else{
		document.getElementById("points").style.opacity = 0.0;
		document.getElementById("logo-text").style.opacity = 1.0;
		document.getElementById("logo-vault").style.opacity = 1.0;
	}
}
function updatePointsRun(pointsRequest) 
{
	if (pointsRequest.status == 200)
	{
		var ex = new RegExp("Rank: ([0-9]{0,6})<br>\n\tPoints: ([0-9]{3,5})<br>\n\tTeam: ([a-zA-Z]*)<br>");
        var match = ex.exec(pointsRequest.responseText);
		
		if(match == null){
			document.getElementById("logo-text").style.opacity = 1.0;
			document.getElementById("logo-vault").style.opacity = 1.0;
			document.getElementById("points").style.opacity = 0.0;
		}	
		else
		{
			userRank = match[1];
			userPoints = parseInt(match[2]);
			userColor = match[3];
			
			document.getElementById("userPoints").innerHTML = _addCommas(userPoints);
			document.getElementById("blueglow").style.opacity = 0.0;
			document.getElementById("greenglow").style.opacity = 0.0;
			document.getElementById("purpleglow").style.opacity = 0.0;
			document.getElementById("orangeglow").style.opacity = 0.0;

			switch(userColor){
				case "Blue":
					document.getElementById("blueglow").style.opacity = 1.0;
					break;
				case "Green":
					document.getElementById("greenglow").style.opacity = 1.0;
					break;
				case "Purple":
					document.getElementById("purpleglow").style.opacity = 1.0;
					break;
				case "Orange":
					document.getElementById("orangeglow").style.opacity = 1.0;
					break;
			}
			document.getElementById("rank").innerHTML = _addSuffix(userRank);
		}
	}
	else
	{
		alert("Error fetching data: HTTP status " + pointsRequest.status);
		document.getElementById("points").style.opacity = 0.0;
		document.getElementById("logo-text").style.opacity = 1.0;
		document.getElementById("logo-vault").style.opacity = 1.0;
	}
}


function aniFadeIn(name)
{
	var itemToFadein = document.getElementById(name); 
	var fadeHandler = function(a, c, s, f){ itemToFadein.style.opacity = c; };
	new AppleAnimator(500, 13, 0.0, 1.0, fadeHandler).start();
}

// Code from http://macpomme.com/?p=35
function _getVersion()
{
	var infoPlist = new XMLHttpRequest(); 
    infoPlist.open("GET", "Info.plist", false); 
    infoPlist.send(null); 
    var infoXML = infoPlist.responseXML;
    var nodes = infoXML.getElementsByTagName("dict")[0].childNodes;
    var key_value = ""; 
    for (var i=0; i < nodes.length; i++)
	{ 
		if (nodes[i].nodeType == 1 && nodes[i].tagName.toLowerCase() == "key" && nodes[i].firstChild.data == "CFBundleVersion")
		{ 
			if (nodes[i+2].tagName.toLowerCase() != "array")
				key_value = nodes[i+2].firstChild.data; 
			else
			{ 
				key_value = new Array(); 
				var ar_nodes = nodes[i+2].childNodes; 
				for (var j=0; j < ar_nodes.length; j++)
				{ 
					if (ar_nodes[j].nodeType == 1)
						key_value.push(ar_nodes[j].firstChild.data); 
				} 
			} 
			break; 
		}
	} 
	return key_value; 
}

//Code from http://www.mredkj.com/javascript/nfbasic.html
function _addCommas(nStr)
{
	nStr += '';
	x = nStr.split('.');
	x1 = x[0];
	x2 = x.length > 1 ? '.' + x[1] : '';
	var rgx = /(\d+)(\d{3})/;
	while (rgx.test(x1)) {
		x1 = x1.replace(rgx, '$1' + ',' + '$2');
	}
	return x1 + x2;
}

function _addSuffix(n)
{
	var val = n[n.length - 1];
	var suffix = "";
	if (val == 1)
		suffix = "st";
	else if (val == 2)
		suffix = "nd";
	else if (val == 3)
		suffix = "rd";
	else
		suffix = "th";
	return n + "<sup>" + suffix + "</sup>";
}

